//
// p-expr.c,  8 Jun 23

#include <ctype.h>
#include <float.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NEAR_ZERO FLT_MIN

typedef double expr_type;

expr_type t(expr_type, int);

#include "e.h"

#define NUMITER 200
#define NUMOPS (NUMVARS-1)

expr_type pert=1;


// Random number in range -1..1
// Uniform distribution
expr_type random_m1_p1(void)
{
expr_type d= (expr_type)rand() / (expr_type)RAND_MAX;

return d*2.0-1.0;
}

// Fill v with random values
void mk_rand(void)
{
int i;
for (i=0; i<NUMVARS; i++)
   v[i]=random_m1_p1();
}


// Print the value v, with indentation o_pos
expr_type t(expr_type v, int o_pos)
{
/*
int i;

for (i=0; i < o_pos; i++)
   printf(" ");
printf("%g\n", v);
*/

return v;
}

void save_results(void)
{
int i, j;

for (i=0; i<NUMEXPR; i++)
   {
   for (j=0; j<NUMOPS; j++)
      if (R[i] == P[j][i])
         printf("%d,%d,%g\n", i, j, R[i]);
      // printf("%e,", R[i]-P[j][i]);
   // printf("\n");
   }
}


void write_header(void)
{
int i;
printf("expr,opnum,result\n");
/*
for (i=0; i<NUMOPS; i++)
   printf("v%d,", i+1);
printf("\n");
*/
}


void eval_expr(void)
{
int i;

for (i=0; i<NUMEXPR; i++)
   pe[i]();
}



int main(int argc, char **argv)
{
int iter;

srand(NUMVARS); // set seed

// printf("%s | %s\n", argv[0], argv[1]);
if (argc > 1)
   pert=atof(argv[1]);

printf("pert=%g\n", pert);

// printf("%f\n", random_m1_p1());

/*
int i;
mk_rand();
for (i=0; i<NUMVARS; i++)
   printf("%d %f\n", i, v[i]);
exit(0);
*/


write_header();
for (iter=0; iter < NUMITER; iter++)
   {
   mk_rand();
   eval_expr();
   save_results();
   }
}

