#
# polish2trace.awk, 10 Jun 23

# Convert a reverse polish expression to postfix form
# Randomly selecting the binary operators
# and inserting a perturbation

# Input has the form:
# o v v
# o v o v v
# o v o v o v v
function eval(tnum, parent, rhs, binop)
{
if ($tnum == "o")
   {
   curparen++
   thisnest++
   parent=tnum
   printf("t")
   printf("(")
   if (curparen == pert_nest)
      printf("t(pert, %d, \"P\", %d, %d)+", thisnest, parent, tnum+1)
   tnum=eval(tnum+1) #recurse for lhs
   if (rand() <= PLUSMUL) # default 0.5
      binop="+"
   else
      binop="*"
   printf("%s", binop)
#   printf("%s", binops[1+int(numops*rand())])
   rhs=tnum
   tnum=eval(tnum) #recurse for rhs
   printf(", %d, \"%s\", %d, %d)", thisnest, binop, parent, rhs)
   thisnest--
   }
else
   {
   printf("t(v[%d], %d, \"v\", %d, %d)", numvars, thisnest, tnum, 0)
   tnum++
   numvars++ # C is zero based
   }

return tnum
}

function pert_expr()
{
# for (i=0; i <numops; i++)
#    {
   srand(numexpr)
   pert_nest=PERTPOS
   curparen=0
   numvars=0
   printf("P[%d][%d] = ", i, numexpr)
   eval(1)
   printf(";\n")
#    }
}


BEGIN {
	numexpr=0
	printf("#define NUMEXPR %d\n", NEXPR)
	printf("#define NUMVARS %d\n", NVARS)
	printf("expr_type R[NUMEXPR], P[NUMVARS][NUMEXPR], v[NUMVARS], pert;\n")
	}


	{
	srand(numexpr)
	pert_nest=-1
	curparen=0
	numvars=0
	thisnest=0
	printf("void f%d(void)\n", numexpr)
	printf("{\n")
	# printf("R[%d] = ", numexpr)
	# eval(1)
	# printf(";\n")
	pert_expr()
	printf("}\n")
	numexpr++ # C is zero based
	next
	}

END {
	printf("void (*(pe[]))(void)={\n")
	for (i=0; i < numexpr; i++)
	   printf("f%d,", i)
	printf("};\n\n\n")
	}

