//
// tp-expr.c, 10 Jun 23

#include <ctype.h>
#include <float.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NEAR_ZERO FLT_MIN

typedef float expr_type;

expr_type t(expr_type, int, char *, int, int);

int print_tree = 1; // True if trace generates dot commands to display an expression tree
int print_results;


#include "e.h"

#define NUMITER 1
#define NUMOPS (NUMVARS-1)

expr_type pert=1;


// Random number in range -1..1
// Uniform distribution
expr_type random_m1_p1(void)
{
expr_type d= (expr_type)rand() / (expr_type)RAND_MAX;

return d*2.0-1.0;
}

// Fill v with random values
void mk_rand(void)
{
int i;
for (i=0; i<NUMVARS; i++)
   v[i]=random_m1_p1();
}


void node_op(char *binop, int node, int child)
{
if (strcmp(binop, "*"))
   printf("n%d -> n%d [color=green];\n", child, node);
else
   printf("n%d -> n%d;\n", child, node);
}


// Print the value v, with indentation o_pos
expr_type t(expr_type v, int o_pos, char *binop, int node, int child)
{
if (print_tree)
   {
   if (strcmp(binop, "v") == 0)
      printf("n%d [label=\"%.2e\"];\n", node, v);
   else
      if (strcmp(binop, "P") == 0)
         {
         printf("Pert -> n%d [color=red];\n", node);
         printf("Pert [label=\"+\\n%.2e\", fontcolor=red, color=red];\n", v);
         }
      else
         {
         node_op(binop, node, node+1);
         node_op(binop, node, child);
         if (strcmp(binop, "*"))
            printf("n%d [label=\"%.2e\\n%s\", fontcolor=green];\n", node, v, binop);
         else
            printf("n%d [label=\"%.2e\\n%s\"];\n", node, v, binop);
         } 
   }
else
   {
   int i;

   for (i=0; i < o_pos; i++)
      printf(" ");
   printf("%s %.1e\n", binop, v);
   }

return v;
}

void save_results(void)
{
int i, j;

for (i=0; i<NUMEXPR; i++)
   {
   for (j=0; j<NUMOPS; j++)
      if (R[i] == P[j][i])
         printf("%d,%d,%g\n", i, j, R[i]);
      // printf("%e,", R[i]-P[j][i]);
   // printf("\n");
   }
}


void write_header(void)
{
/*
int i;

for (i=0; i<NUMOPS; i++)
   printf("v%d,", i+1);
printf("\n");
*/
}


void eval_expr(void)
{
int i;

for (i=0; i<NUMEXPR; i++)
   {
   if (print_tree)
      {
      printf("digraph e_tree {\n");
      printf("node [fontsize=32];\n");
      printf("node [shape=plaintext];\n");
      printf("node[fontname=Helvetica];\n");
      }
   pe[i]();
   if (print_tree)
      printf("}\n");
   }
}



int main(int argc, char **argv)
{
int iter;

srand(NUMVARS); // set seed

// printf("%s | %s\n", argv[0], argv[1]);
if (argc > 1)
   pert=atof(argv[1]);

// printf("%f\n", random_m1_p1());

/*
int i;
mk_rand();
for (i=0; i<NUMVARS; i++)
   printf("%d %f\n", i, v[i]);
exit(0);
*/

print_results=!print_tree;

if (print_results)
   write_header();
for (iter=0; iter < NUMITER; iter++)
   {
   mk_rand();
   eval_expr();
   if (print_results)
      save_results();
   }
}

